Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/dtatsd.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/dtatsd.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/dtatsd.F90	(revision 10986)
@@ -87,4 +87,5 @@
             WRITE(numout,*) '   ===>>   T & S data not used'
          ENDIF
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -184,4 +185,5 @@
             WRITE(numout,*)
             WRITE(numout,*) 'dta_tsd: interpolates T & S data onto the s- or mixed s-z-coordinate mesh'
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
          !
@@ -243,5 +245,8 @@
       IF( .NOT.ln_tsd_dmp ) THEN                   !==   deallocate T & S structure   ==! 
          !                                              (data used only for initialisation)
-         IF(lwp .AND. nprint > 1) WRITE(numout,*) 'dta_tsd: deallocte T & S arrays as they are only use to initialize the run'
+         IF(lwp .AND. nprint > 1) THEN
+            WRITE(numout,*) 'dta_tsd: deallocte T & S arrays as they are only use to initialize the run'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
                                         DEALLOCATE( sf_tsd(jp_tem)%fnow )     ! T arrays in the structure
          IF( sf_tsd(jp_tem)%ln_tint )   DEALLOCATE( sf_tsd(jp_tem)%fdta )
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/iscplhsb.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/iscplhsb.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/iscplhsb.F90	(revision 10986)
@@ -170,4 +170,5 @@
                            WRITE(numout,*) '                     ',ji,' ',jj,' ',jk,' ',narea
                            WRITE(numout,*) ' we are now looking for the closest wet cell on the horizontal '
+                           IF(lflush) CALL FLUSH(numout)
                            ENDIF
                         ! We deal with these points later.
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/iscplini.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/iscplini.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/iscplini.F90	(revision 10986)
@@ -83,4 +83,5 @@
          WRITE(numout,*) ' coupling time step                       = ', rdt_iscpl
          WRITE(numout,*) ' number of call of the extrapolation loop = ', nn_drown
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/istate.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/istate.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/istate.F90	(revision 10986)
@@ -63,7 +63,10 @@
       !!----------------------------------------------------------------------
       !
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'istate_init : Initialization of the dynamics and tracers'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'istate_init : Initialization of the dynamics and tracers'
+         WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
 
 !!gm  Why not include in the first call of dta_tsd ?  
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/phycst.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/phycst.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DOM/phycst.F90	(revision 10986)
@@ -132,4 +132,5 @@
          WRITE(numout,*)
          WRITE(numout,*) '      smallest real computer value       rsmall = ', rsmall
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/divhor.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/divhor.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/divhor.F90	(revision 10986)
@@ -72,4 +72,5 @@
          IF(lwp) WRITE(numout,*) 'div_hor : horizontal velocity divergence '
          IF(lwp) WRITE(numout,*) '~~~~~~~   '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynadv.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynadv.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynadv.F90	(revision 10986)
@@ -102,4 +102,5 @@
          WRITE(numout,*) 'dyn_adv_init : choice/control of the momentum advection scheme'
          WRITE(numout,*) '~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -119,4 +120,5 @@
          WRITE(numout,*) '      flux form: 2nd order centred scheme              ln_dynadv_cen2 = ', ln_dynadv_cen2
          WRITE(numout,*) '                 3rd order UBS scheme                  ln_dynadv_ubs  = ', ln_dynadv_ubs
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -141,4 +143,5 @@
          CASE( np_FLX_ubs )   ;   WRITE(numout,*) '   ==>>>   flux form   : UBS       scheme is used'
          END SELECT
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynadv_cen2.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynadv_cen2.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynadv_cen2.F90	(revision 10986)
@@ -57,4 +57,5 @@
          WRITE(numout,*) 'dyn_adv_cen2 : 2nd order flux form momentum advection'
          WRITE(numout,*) '~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynadv_ubs.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynadv_ubs.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynadv_ubs.F90	(revision 10986)
@@ -82,4 +82,5 @@
          IF(lwp) WRITE(numout,*) 'dyn_adv_ubs : UBS flux form momentum advection'
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynhpg.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynhpg.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynhpg.F90	(revision 10986)
@@ -170,4 +170,5 @@
          WRITE(numout,*) '      s-coord. (Density Jacobian: Cubic polynomial)     ln_hpg_djc    = ', ln_hpg_djc
          WRITE(numout,*) '      s-coord. (Pressure Jacobian: Cubic polynomial)    ln_hpg_prj    = ', ln_hpg_prj
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -211,4 +212,5 @@
          END SELECT
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !                          
@@ -218,6 +220,9 @@
       ELSE                            !--- set an ice shelf load
          !
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) '   ice shelf case: set the ice-shelf load'
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) '   ice shelf case: set the ice-shelf load'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          ALLOCATE( zts_top(jpi,jpj,jpts) , zrhd(jpi,jpj,jpk) , zrhdtop_isf(jpi,jpj) , ziceload(jpi,jpj) ) 
          !
@@ -279,8 +284,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn:hpg_zco : hydrostatic pressure gradient trend'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   z-coordinate case '
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn:hpg_zco : hydrostatic pressure gradient trend'
+         WRITE(numout,*) '~~~~~~~~~~~   z-coordinate case '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -340,8 +346,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn:hpg_zps : hydrostatic pressure gradient trend'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   z-coordinate with partial steps - vector optimization'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn:hpg_zps : hydrostatic pressure gradient trend'
+         WRITE(numout,*) '~~~~~~~~~~~   z-coordinate with partial steps - vector optimization'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -439,8 +446,9 @@
       IF( ln_wd_il ) ALLOCATE(zcpx(jpi,jpj), zcpy(jpi,jpj))
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn:hpg_sco : hydrostatic pressure gradient trend'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   s-coordinate case, OPA original scheme used'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn:hpg_sco : hydrostatic pressure gradient trend'
+         WRITE(numout,*) '~~~~~~~~~~~   s-coordinate case, OPA original scheme used'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -726,8 +734,9 @@
       END IF
 
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn:hpg_djc : hydrostatic pressure gradient trend'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   s-coordinate case, density Jacobian with cubic polynomial scheme'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn:hpg_djc : hydrostatic pressure gradient trend'
+         WRITE(numout,*) '~~~~~~~~~~~   s-coordinate case, density Jacobian with cubic polynomial scheme'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -960,8 +969,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn:hpg_prj : hydrostatic pressure gradient trend'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   s-coordinate case, cubic spline pressure Jacobian'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn:hpg_prj : hydrostatic pressure gradient trend'
+         WRITE(numout,*) '~~~~~~~~~~~   s-coordinate case, cubic spline pressure Jacobian'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynkeg.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynkeg.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynkeg.F90	(revision 10986)
@@ -84,8 +84,9 @@
       IF( ln_timing )   CALL timing_start('dyn_keg')
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn_keg : kinetic energy gradient trend, scheme number=', kscheme
-         IF(lwp) WRITE(numout,*) '~~~~~~~'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn_keg : kinetic energy gradient trend, scheme number=', kscheme
+         WRITE(numout,*) '~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynldf.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynldf.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynldf.F90	(revision 10986)
@@ -106,4 +106,5 @@
          CASE( np_blp    )   ;   WRITE(numout,*) '   ==>>>   iso-level bi-laplacian operator'
          END SELECT
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynldf_iso.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynldf_iso.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynldf_iso.F90	(revision 10986)
@@ -114,7 +114,10 @@
       !
       IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn_ldf_iso : iso-neutral laplacian diffusive operator or '
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   s-coordinate horizontal diffusive operator'
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'dyn_ldf_iso : iso-neutral laplacian diffusive operator or '
+            WRITE(numout,*) '~~~~~~~~~~~   s-coordinate horizontal diffusive operator'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !                                      ! allocate dyn_ldf_bilap arrays
          IF( dyn_ldf_iso_alloc() /= 0 )   CALL ctl_stop('STOP', 'dyn_ldf_iso: failed to allocate arrays')
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynldf_lap_blp.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynldf_lap_blp.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynldf_lap_blp.F90	(revision 10986)
@@ -62,4 +62,5 @@
          WRITE(numout,*) 'dyn_ldf : iso-level harmonic (laplacian) operator, pass=', kpass
          WRITE(numout,*) '~~~~~~~ '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -129,4 +130,5 @@
          IF(lwp) WRITE(numout,*) 'dyn_ldf_blp : bilaplacian operator momentum '
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynnxt.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynnxt.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynnxt.F90	(revision 10986)
@@ -106,8 +106,9 @@
       IF( l_trddyn     )   ALLOCATE( zua(jpi,jpj,jpk) , zva(jpi,jpj,jpk) )
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn_nxt : time stepping'
-         IF(lwp) WRITE(numout,*) '~~~~~~~'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn_nxt : time stepping'
+         WRITE(numout,*) '~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynspg.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynspg.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynspg.F90	(revision 10986)
@@ -198,4 +198,5 @@
          WRITE(numout,*) 'dyn_spg_init : choice of the surface pressure gradient scheme'
          WRITE(numout,*) '~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -213,4 +214,5 @@
          WRITE(numout,*) '      Explicit free surface                  ln_dynspg_exp = ', ln_dynspg_exp
          WRITE(numout,*) '      Free surface with time splitting       ln_dynspg_ts  = ', ln_dynspg_ts
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !                          ! Control of surface pressure gradient scheme options
@@ -229,4 +231,5 @@
          IF( nspg == np_TS  )   WRITE(numout,*) '   ==>>>   free surface with time splitting scheme'
          IF( nspg == np_NO  )   WRITE(numout,*) '   ==>>>   No surface surface pressure gradient trend in momentum Eqs.'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynspg_exp.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynspg_exp.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynspg_exp.F90	(revision 10986)
@@ -61,11 +61,17 @@
       !
       IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn_spg_exp : surface pressure gradient trend'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   (explicit free surface)'
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'dyn_spg_exp : surface pressure gradient trend'
+            WRITE(numout,*) '~~~~~~~~~~~   (explicit free surface)'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
          spgu(:,:) = 0._wp   ;   spgv(:,:) = 0._wp
          !
-         IF( .NOT.ln_linssh .AND. lwp ) WRITE(numout,*) '      non linear free surface: spg is included in dynhpg'
+         IF( .NOT.ln_linssh .AND. lwp ) THEN
+            WRITE(numout,*) '      non linear free surface: spg is included in dynhpg'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
       ENDIF
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynspg_ts.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynspg_ts.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynspg_ts.F90	(revision 10986)
@@ -197,8 +197,11 @@
       IF( kt == nit000 ) THEN                   !* initialisation
          !
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn_spg_ts : surface pressure gradient trend'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~   free surface with time splitting'
-         IF(lwp) WRITE(numout,*)
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'dyn_spg_ts : surface pressure gradient trend'
+            WRITE(numout,*) '~~~~~~~~~~   free surface with time splitting'
+            WRITE(numout,*)
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
          IF( neuler == 0 )   ll_init=.TRUE.
@@ -1422,6 +1425,9 @@
 #endif
          ELSE                                   !* Start from rest
-            IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) '   ==>>>   start from rest: set barotropic values to 0'
+            IF(lwp) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) '   ==>>>   start from rest: set barotropic values to 0'
+               IF(lflush) CALL FLUSH(numout) 
+            ENDIF
             ub2_b (:,:) = 0._wp   ;   vb2_b (:,:) = 0._wp   ! used in the 1st interpol of agrif
             un_adv(:,:) = 0._wp   ;   vn_adv(:,:) = 0._wp   ! used in the 1st interpol of agrif
@@ -1436,5 +1442,8 @@
       ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN   ! Create restart file
          !                                   ! -------------------
-         IF(lwp .AND. nprint > 0) WRITE(numout,*) '---- ts_rst ----'
+         IF(lwp .AND. nprint > 0) THEN
+            WRITE(numout,*) '---- ts_rst ----'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          IF( lwxios ) CALL iom_swap(      cwxios_context          )
          CALL iom_rstput( kt, nitrst, numrow, 'ub2_b'   , ub2_b  (:,:), ldxios = lwxios )
@@ -1494,25 +1503,28 @@
       zcmax = zcmax * rdtbt
       ! Print results
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'dyn_spg_ts_init : split-explicit free surface'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~'
-      IF( ln_bt_auto ) THEN
-         IF(lwp) WRITE(numout,*) '     ln_ts_auto =.true. Automatically set nn_baro '
-         IF(lwp) WRITE(numout,*) '     Max. courant number allowed: ', rn_bt_cmax
-      ELSE
-         IF(lwp) WRITE(numout,*) '     ln_ts_auto=.false.: Use nn_baro in namelist   nn_baro = ', nn_baro
-      ENDIF
-
-      IF(ln_bt_av) THEN
-         IF(lwp) WRITE(numout,*) '     ln_bt_av =.true.  ==> Time averaging over nn_baro time steps is on '
-      ELSE
-         IF(lwp) WRITE(numout,*) '     ln_bt_av =.false. => No time averaging of barotropic variables '
-      ENDIF
-      !
-      !
-      IF(ln_bt_fw) THEN
-         IF(lwp) WRITE(numout,*) '     ln_bt_fw=.true.  => Forward integration of barotropic variables '
-      ELSE
-         IF(lwp) WRITE(numout,*) '     ln_bt_fw =.false.=> Centred integration of barotropic variables '
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn_spg_ts_init : split-explicit free surface'
+         WRITE(numout,*) '~~~~~~~~~~~~~~~'
+         IF( ln_bt_auto ) THEN
+            WRITE(numout,*) '     ln_ts_auto =.true. Automatically set nn_baro '
+            WRITE(numout,*) '     Max. courant number allowed: ', rn_bt_cmax
+         ELSE
+            WRITE(numout,*) '     ln_ts_auto=.false.: Use nn_baro in namelist   nn_baro = ', nn_baro
+         ENDIF
+
+         IF(ln_bt_av) THEN
+            WRITE(numout,*) '     ln_bt_av =.true.  ==> Time averaging over nn_baro time steps is on '
+         ELSE
+            WRITE(numout,*) '     ln_bt_av =.false. => No time averaging of barotropic variables '
+         ENDIF
+      !
+      !
+         IF(ln_bt_fw) THEN
+            WRITE(numout,*) '     ln_bt_fw=.true.  => Forward integration of barotropic variables '
+         ELSE
+            WRITE(numout,*) '     ln_bt_fw =.false.=> Centred integration of barotropic variables '
+         ENDIF
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -1530,10 +1542,13 @@
       END SELECT
       !
-      IF(lwp) WRITE(numout,*) ' '
-      IF(lwp) WRITE(numout,*) '     nn_baro = ', nn_baro
-      IF(lwp) WRITE(numout,*) '     Barotropic time step [s] is :', rdtbt
-      IF(lwp) WRITE(numout,*) '     Maximum Courant number is   :', zcmax
-      !
-      IF(lwp) WRITE(numout,*)    '     Time diffusion parameter rn_bt_alpha: ', rn_bt_alpha
+      IF(lwp) THEN
+         WRITE(numout,*) ' '
+         WRITE(numout,*) '     nn_baro = ', nn_baro
+         WRITE(numout,*) '     Barotropic time step [s] is :', rdtbt
+         WRITE(numout,*) '     Maximum Courant number is   :', zcmax
+      !
+         WRITE(numout,*)    '     Time diffusion parameter rn_bt_alpha: ', rn_bt_alpha
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       IF ((ln_bt_av.AND.nn_bt_flt/=0).AND.(rn_bt_alpha>0._wp)) THEN
          CALL ctl_stop( 'dynspg_ts ERROR: if rn_bt_alpha > 0, remove temporal averaging' )
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynvor.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynvor.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynvor.F90	(revision 10986)
@@ -220,4 +220,5 @@
          IF(lwp) WRITE(numout,*) 'dyn:vor_enT : vorticity term: t-point energy conserving scheme'
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -352,8 +353,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn:vor_ene : vorticity term: energy conserving scheme'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn:vor_ene : vorticity term: energy conserving scheme'
+         WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -460,8 +462,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn:vor_ens : vorticity term: enstrophy conserving scheme'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn:vor_ens : vorticity term: enstrophy conserving scheme'
+         WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !                                                ! ===============
@@ -568,8 +571,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn:vor_een : vorticity term: energy and enstrophy conserving scheme'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn:vor_een : vorticity term: energy and enstrophy conserving scheme'
+         WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -725,8 +729,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn:vor_een : vorticity term: energy and enstrophy conserving scheme'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dyn:vor_een : vorticity term: energy and enstrophy conserving scheme'
+         WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -847,4 +852,5 @@
          WRITE(numout,*) 'dyn_vor_init : vorticity term : read namelist and control the consistency'
          WRITE(numout,*) '~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -867,4 +873,5 @@
          WRITE(numout,*) '      mixed enstrophy/energy conserving scheme       ln_dynvor_mix = ', ln_dynvor_mix
          WRITE(numout,*) '      masked (=T) or unmasked(=F) vorticity          ln_dynvor_msk = ', ln_dynvor_msk
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -874,6 +881,9 @@
       ! If energy, enstrophy or mixed advection of momentum in vector form change the value for masks
       ! at angles with three ocean points and one land point
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '      change fmask value in the angles (T)           ln_vorlat = ', ln_vorlat
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) '      change fmask value in the angles (T)           ln_vorlat = ', ln_vorlat
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       IF( ln_vorlat .AND. ( ln_dynvor_ene .OR. ln_dynvor_ens .OR. ln_dynvor_mix ) ) THEN
          DO jk = 1, jpk
@@ -951,4 +961,5 @@
          CASE( np_MIX )   ;   WRITE(numout,*) '   ==>>>   mixed enstrophy/energy conserving scheme (MIX)'
          END SELECT         
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynzad.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynzad.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynzad.F90	(revision 10986)
@@ -66,4 +66,5 @@
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'dyn_zad : 2nd order vertical advection scheme'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynzdf.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynzdf.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/dynzdf.F90	(revision 10986)
@@ -82,7 +82,10 @@
       !
       IF( kt == nit000 ) THEN       !* initialization
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn_zdf_imp : vertical momentum diffusion implicit operator'
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~ '
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'dyn_zdf_imp : vertical momentum diffusion implicit operator'
+            WRITE(numout,*) '~~~~~~~~~~~ '
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
          If( ln_linssh ) THEN   ;    r_vvl = 0._wp    ! non-linear free surface indicator
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/sshwzv.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/sshwzv.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/sshwzv.F90	(revision 10986)
@@ -77,8 +77,9 @@
       IF( ln_timing )   CALL timing_start('ssh_nxt')
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'ssh_nxt : after sea surface height'
-         IF(lwp) WRITE(numout,*) '~~~~~~~ '
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'ssh_nxt : after sea surface height'
+         WRITE(numout,*) '~~~~~~~ '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -152,7 +153,10 @@
       !
       IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'wzv : now vertical velocity '
-         IF(lwp) WRITE(numout,*) '~~~~~ '
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'wzv : now vertical velocity '
+            WRITE(numout,*) '~~~~~ '
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
          wn(:,:,jpk) = 0._wp                  ! bottom boundary condition: w=0 (set once for all)
@@ -240,8 +244,9 @@
       IF( ln_timing )   CALL timing_start('ssh_swp')
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'ssh_swp : Asselin time filter and swap of sea surface height'
-         IF(lwp) WRITE(numout,*) '~~~~~~~ '
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'ssh_swp : Asselin time filter and swap of sea surface height'
+         WRITE(numout,*) '~~~~~~~ '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !              !==  Euler time-stepping: no filter, just swap  ==!
@@ -294,7 +299,10 @@
       !
       IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'wAimp : Courant number-based partitioning of now vertical velocity '
-         IF(lwp) WRITE(numout,*) '~~~~~ '
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'wAimp : Courant number-based partitioning of now vertical velocity '
+            WRITE(numout,*) '~~~~~ '
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
          Cu_adv(:,:,jpk) = 0._wp              ! bottom value : Cu_adv=0 (set once for all)
